
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>

// ------------------------------------------------------------------------------------------------
// Constants

// wing it.
#define PATH_BUFFER_SIZE 300

// ------------------------------------------------------------------------------------------------
// Helpers

bool streq(const char* a, const char* b) {
	return strcmp(a, b) == 0;
}

void fatal(const char* format, ...) {
	va_list args;
	va_start(args, format);
	vfprintf(stderr, format, args);
	fprintf(stderr, "\n");
	va_end(args);
	exit(1);
}

#define CHECKED_FREAD(f, ptr, filename)\
	if(fread((ptr), sizeof(*(ptr)), 1, (f)) == 0) {\
		fatal("failed to read from %s.", (filename));\
	}

#define CHECKED_FWRITE(f, ptr, filename)\
	if(fwrite((ptr), sizeof(*(ptr)), 1, (f)) == 0) {\
		fatal("failed to write to %s.", (filename));\
	}

#define CHECKED_FREAD_SIZE(f, ptr, size, filename)\
	if(fread((ptr), (size), 1, (f)) == 0) {\
		fatal("failed to read from %s.", (filename));\
	}

#define CHECKED_FWRITE_SIZE(f, ptr, size, filename)\
	if(fwrite((ptr), (size), 1, (f)) == 0) {\
		fatal("failed to write to %s.", (filename));\
	}

// ------------------------------------------------------------------------------------------------
// OpenBMP

typedef struct {
	FILE*    in;
	FILE*    out;
	uint32_t pixelStart;
	uint32_t width;
	uint32_t height;
	uint32_t padding;
} OpenBMP;

// ------------------------------------------------------------------------------------------------
// Pixel

typedef struct {
	uint8_t b;
	uint8_t g;
	uint8_t r;
} Pixel;

// ------------------------------------------------------------------------------------------------
// Functions!!!!!

void print_info(const char* in_filename) {

}

void invert_image(const char* in_filename) {

}

void grayscale_image(const char* in_filename) {

}

void hflip_image(const char* in_filename) {

}

// ------------------------------------------------------------------------------------------------
// main

int main(int argc, char** argv) {
	if(argc == 3 && streq(argv[1], "info")) {
		print_info(argv[2]);
	} else if(argc == 3 && streq(argv[1], "invert")) {
		invert_image(argv[2]);
	} else if(argc == 3 && streq(argv[1], "grayscale")) {
		grayscale_image(argv[2]);
	} else if(argc == 3 && streq(argv[1], "hflip")) {
		hflip_image(argv[2]);
	} else {
		printf("Usage:\n");
		printf("  %s info filename.bmp\n", argv[0]);
		printf("     Checks that filename.bmp is a BMP file and prints some info about it.\n");
		printf("  %s invert filename.bmp\n", argv[0]);
		printf("     Produces inv_filename.bmp with the colors inverted.\n");
		printf("  %s grayscale filename.bmp\n", argv[0]);
		printf("     Produces gray_filename.bmp with the colors converted to grayscale.\n");
		printf("  %s hflip filename.bmp\n", argv[0]);
		printf("     Produces hflip_filename.bmp with the pixels flipped horizontally.\n");
		return 1;
	}

	return 0;
}